Index: trunk/kernel/kern/rpc.c
===================================================================
--- trunk/kernel/kern/rpc.c	(revision 690)
+++ trunk/kernel/kern/rpc.c	(revision 1)
@@ -1689,40 +516,30 @@
                                   error_t      * error )     // out
 {
-#if DEBUG_RPC_VFS_INODE_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target cluster is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
     // initialise RPC descriptor header 
     rpc_desc_t  rpc;
     rpc.index    = RPC_VFS_INODE_CREATE;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)fs_type;
-    rpc.args[1] = (uint64_t)attr;
-    rpc.args[2] = (uint64_t)rights;
-    rpc.args[3] = (uint64_t)uid;
-    rpc.args[4] = (uint64_t)gid;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
+    rpc.args[0] = (uint64_t)dentry_xp;
+    rpc.args[1] = (uint64_t)type;
+    rpc.args[2] = (uint64_t)attr;
+    rpc.args[3] = (uint64_t)mode;
+    rpc.args[4] = (uint64_t)uid;
+    rpc.args[5] = (uint64_t)gid;
+
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
 
     // get output values from RPC descriptor
-    *inode_xp = (xptr_t)rpc.args[5];
-    *error    = (error_t)rpc.args[6];
-
-#if DEBUG_RPC_VFS_INODE_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
+    *inode_xp = (xptr_t)rpc.args[6];
+    *error    = (error_t)rpc.args[7];
 }
 
@@ -1730,15 +547,8 @@
 void rpc_vfs_inode_create_server( xptr_t xp )
 {
-#if DEBUG_RPC_VFS_INODE_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t         fs_type;
+    xptr_t           dentry_xp;
+    uint32_t         type;
     uint32_t         attr;
-    uint32_t         rights;
+    uint32_t         mode;
     uint32_t         uid;
     uint32_t         gid;
@@ -1747,18 +557,20 @@
 
     // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
 
     // get input arguments from client rpc descriptor
-    fs_type    = (uint32_t)  hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-    attr       = (uint32_t)  hal_remote_l64( XPTR( client_cxy , &desc->args[1] ) );
-    rights     = (uint32_t)  hal_remote_l64( XPTR( client_cxy , &desc->args[2] ) );
-    uid        = (uid_t)     hal_remote_l64( XPTR( client_cxy , &desc->args[3] ) );
-    gid        = (gid_t)     hal_remote_l64( XPTR( client_cxy , &desc->args[4] ) );
+    dentry_xp = (xptr_t)  hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+    type      = (uint32_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[1] ) );
+    attr      = (uint32_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[2] ) );
+    mode      = (uint32_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[3] ) );
+    uid       = (uid_t)   hal_remote_lwd( XPTR( client_cxy , &desc->args[4] ) );
+    gid       = (gid_t)   hal_remote_lwd( XPTR( client_cxy , &desc->args[5] ) );
 
     // call local kernel function
-    error = vfs_inode_create( fs_type,
+    error = vfs_inode_create( dentry_xp,
+                              type,
                               attr,
-                              rights,
+                              mode,
                               uid,
                               gid,
@@ -1766,49 +578,33 @@
 
     // set output arguments
-    hal_remote_s64( XPTR( client_cxy , &desc->args[5] ) , (uint64_t)inode_xp );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[6] ) , (uint64_t)error );
-
-#if DEBUG_RPC_VFS_INODE_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [11]  to RPC_VFS_INODE_DESTROY   deprecated [AG] dec 2019
-/////////////////////////////////////////////////////////////////////////////////////////
+    hal_remote_swd( XPTR( client_cxy , &desc->args[6] ) , (uint64_t)inode_xp );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[7] ) , (uint64_t)error );
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_VFS_INODE_DESTROY 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+/////////////////////////////////////////////////////////////
 void rpc_vfs_inode_destroy_client( cxy_t                cxy,
                                    struct vfs_inode_s * inode )
 {
-#if DEBUG_RPC_VFS_INODE_DESTROY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_DESTROY )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t responses = 1;
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target cluster is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
     // initialise RPC descriptor header 
     rpc_desc_t  rpc;
     rpc.index    = RPC_VFS_INODE_DESTROY;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
     rpc.args[0] = (uint64_t)(intptr_t)inode;
     
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-#if DEBUG_RPC_VFS_INODE_DESTROY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_DESTROY )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
 }
 
@@ -1816,74 +612,53 @@
 void rpc_vfs_inode_destroy_server( xptr_t xp )
 {
-#if DEBUG_RPC_VFS_INODE_DESTROY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_DESTROY )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
     vfs_inode_t * inode;
 
     // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get argument "inode" from client RPC descriptor
-    inode = (vfs_inode_t *)(intptr_t)hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
+
+    // get arguments "inode" from client RPC descriptor
+    inode = (vfs_inode_t *)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
                        
     // call local kernel function
     vfs_inode_destroy( inode );
-
-#if DEBUG_RPC_VFS_INODE_DESTROY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_INODE_DESTROY )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [12]  RPC_VFS_DENTRY_CREATE   deprecated [AG] dec 2019
-/////////////////////////////////////////////////////////////////////////////////////////
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_VFS_DENTRY_CREATE
+/////////////////////////////////////////////////////////////////////////////////////////
+
+//////////////////////////////////////////////////////////////
 void rpc_vfs_dentry_create_client( cxy_t                  cxy,
                                    uint32_t               type,         // in
                                    char                 * name,         // in
+                                   struct vfs_inode_s   * parent,       // in
                                    xptr_t               * dentry_xp,    // out
                                    error_t              * error )       // out
 {
-#if DEBUG_RPC_VFS_DENTRY_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_DENTRY_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t responses = 1;
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target cluster is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
     // initialise RPC descriptor header 
     rpc_desc_t  rpc;
     rpc.index    = RPC_VFS_DENTRY_CREATE;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
     rpc.args[0] = (uint64_t)type;
     rpc.args[1] = (uint64_t)(intptr_t)name;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
+    rpc.args[2] = (uint64_t)strlen( name );
+    rpc.args[3] = (uint64_t)(intptr_t)parent;
+
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
 
     // get output values from RPC descriptor
-    *dentry_xp = (xptr_t)rpc.args[2];
-    *error     = (error_t)rpc.args[3];
-
-#if DEBUG_RPC_VFS_DENTRY_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_DENTRY_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
+    *dentry_xp = (xptr_t)rpc.args[4];
+    *error     = (error_t)rpc.args[5];
 }
 
@@ -1891,80 +666,63 @@
 void rpc_vfs_dentry_create_server( xptr_t xp )
 {
-#if DEBUG_RPC_VFS_DENTRY_CREATE
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_DENTRY_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
     uint32_t      type;
     char        * name;
+    vfs_inode_t * parent;
     xptr_t        dentry_xp;
+    char          name_copy[CONFIG_VFS_MAX_NAME_LENGTH];
+    uint32_t      length;
     error_t       error;
-    char          name_copy[CONFIG_VFS_MAX_NAME_LENGTH];
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get arguments "name", "type", and "parent" from client RPC descriptor
-    type   = (uint32_t)         hal_remote_l64( XPTR( client_cxy , &desc->args[0] ) );
-    name   = (char *)(intptr_t) hal_remote_l64( XPTR( client_cxy , &desc->args[1] ) );
-
-    // makes a local copy of  name
-    hal_remote_strcpy( XPTR( local_cxy , name_copy ),
-                       XPTR( client_cxy , name ) );
-
+
+    // get client cluster identifier and pointer on RPC descriptor
+    cxy_t        client_cxy  = (cxy_t)GET_CXY( xp );
+    rpc_desc_t * desc        = (rpc_desc_t *)GET_PTR( xp );
+
+    // get argument "name" & "length" from client RPC descriptor and makes a local copy
+    name   = (char *)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[1] ) );
+    length = (uint32_t)        hal_remote_lwd( XPTR( client_cxy , &desc->args[2] ) );
+    hal_remote_memcpy( XPTR( local_cxy , name_copy ),
+                       XPTR( client_cxy , name ),
+					   length + 1 );               // +1 for the NUL char
+
+    // get arguments "type" and "parent" from client RPC descriptor
+    type   = (uint32_t)               hal_remote_lwd( XPTR( client_cxy , &desc->args[0] ) );
+    parent = (vfs_inode_t *)(intptr_t)hal_remote_lwd( XPTR( client_cxy , &desc->args[3] ) );
+                       
     // call local kernel function
     error = vfs_dentry_create( type,
                                name_copy,
+                               parent,
                                &dentry_xp );
+ 
     // set output arguments
-    hal_remote_s64( XPTR( client_cxy , &desc->args[2] ) , (uint64_t)dentry_xp );
-    hal_remote_s64( XPTR( client_cxy , &desc->args[3] ) , (uint64_t)error );
-
-#if DEBUG_RPC_VFS_DENTRY_CREATE
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_DENTRY_CREATE )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [13]  RPC_VFS_DENTRY_DESTROY   deprecated [AG] dec 2019
-/////////////////////////////////////////////////////////////////////////////////////////
+    hal_remote_swd( XPTR( client_cxy , &desc->args[4] ) , (uint64_t)dentry_xp );
+    hal_remote_swd( XPTR( client_cxy , &desc->args[5] ) , (uint64_t)error );
+}
+
+/////////////////////////////////////////////////////////////////////////////////////////
+//               Marshaling functions attached to RPC_VFS_DENTRY_DESTROY 
+/////////////////////////////////////////////////////////////////////////////////////////
+
+///////////////////////////////////////////////////////
 void rpc_vfs_dentry_destroy_client( cxy_t          cxy,
                                     vfs_dentry_t * dentry )
 {
-#if DEBUG_RPC_VFS_DENTRY_DESTROY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_DENTRY_DESTROY )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
+    // RPC must be remote
+    if( cxy == local_cxy ) 
+    {
+        printk("PANIC in %s : target cluster is not remote\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
 
     // initialise RPC descriptor header 
     rpc_desc_t  rpc;
     rpc.index    = RPC_VFS_DENTRY_DESTROY;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
+    rpc.response = 1;
 
     // set input arguments in RPC descriptor 
     rpc.args[0] = (uint64_t)(intptr_t)dentry;
     
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-#if DEBUG_RPC_VFS_DENTRY_DESTROY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_DENTRY_DESTROY )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
+    // register RPC request in remote RPC fifo (blocking function)
+    rpc_send_sync( cxy , &rpc );
 }
 
